<template lang="pug">

  .container(v-loading="pageLoading")
    .block-typical
      el-form(
      ref='newsForm'
      v-if="inputs.length"
      :model='stateForm'
      :rules="rules")

        el-form-item(
          v-for="item in inputs"
          :key="item.id"
          :style="item.maxWidth ? `max-width:${item.maxWidth}px; margin-bottom: 35px` : 'margin-bottom: 35px'"
          :prop="item.name")
          app-input(
            :placeholder="item.placeholder"
            :model="stateForm[item.name]"
            :name="item.name"
            :id="item.id"
            :label="item.label"
            :type="item.type"
            :prompt="item.prompt"
            :autosize="item.autosize"
            :required="item.required"
            :maxlength="item.maxlength"
            @input-value="modelValue")

    .activity__block
      router-link.el-button.el-button--info.button(
      :to="{path: '/admin/news'}")
        |Отмена

      el-button.button(
      type="success"
      @click="createNews('newsForm')")
        |Создать новость

</template>

<script>
import InputItem from '../../../components/InputItem';

export default {
  layout: 'admin',
  name: 'NewsItem',
  components: {
    'app-input': InputItem
  },
  data() {
    return {
      inputs: [
        {
          id: 1,
          placeholder: 'Укажите заголовок новости',
          model: '',
          label: 'Заголовок',
          name: 'heading',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, заполните поле',
              trigger: 'change'
            }
          ]
        }
      ],
      pageLoading: false
    };
  },
  computed: {
    stateForm() {
      let state = {};
      this.inputs.forEach(item => {
        state[item.name] = item.model;
      });
      return state;
    },
    rules() {
      let rulesObj = {};
      this.inputs.forEach(item => {
        rulesObj[item.name] = item.prop;
      });
      return rulesObj;
    }
  },
  created() {
    this.$store.commit('pages', [
      {
        name: 'Новости',
        slug: '/admin/news'
      }
    ]);
    this.$store.commit('headingTitle', 'Cоздание новости');
    this.$store.commit('publicLink', '');
    this.$store.commit('id', '');
  },
  methods: {
    modelValue(valueArr) {
      let index = this.inputs.findIndex(item => item.id === valueArr[0]);
      this.inputs[index].model = valueArr[1];
    },
    createNews(formName) {
      this.$refs[formName].validate(valid => {
        if (valid) {
          this.pageLoading = true;
          this.$axios
            .post('/api/v1/news/', {
              heading: this.stateForm.heading,
              cover: '',
              text: '',
              active: false
            })
            .then(
              data => {
                this.pageLoading = false;
                this.$router.push(`/admin/news/${data.data.id}`);
                this.$message.success('Новость успешно создана!');
              },
              errorMessage => {
                console.log(errorMessage);
                this.$message.error('Ошибка перезаписи данных!');
                this.pageLoading = false;
              }
            )
            .catch(() => {
              this.$message.error('Ошибка перезаписи данных');
              this.pageLoading = false;
            });
        } else {
          this.$message.error('Пожалуйста, заполните все обязательные поля!');
          return false;
        }
      });
    }
  }
};
</script>
